Open CASCADE Technology  7.3.1.dev
Public Member Functions | Protected Member Functions
AIS_AngleDimension Class Reference

Angle dimension. Can be constructed: More...

#include <AIS_AngleDimension.hxx>

Inheritance diagram for AIS_AngleDimension:
Inheritance graph
[legend]

Public Member Functions

 AIS_AngleDimension (const TopoDS_Edge &theFirstEdge, const TopoDS_Edge &theSecondEdge)
 Constructs minimum angle dimension between two linear edges (where possible). These two edges should be intersected by each other. Otherwise the geometry is not valid. More...
 
 AIS_AngleDimension (const gp_Pnt &theFirstPoint, const gp_Pnt &theSecondPoint, const gp_Pnt &theThirdPoint)
 Constructs the angle display object defined by three points. More...
 
 AIS_AngleDimension (const TopoDS_Vertex &theFirstVertex, const TopoDS_Vertex &theSecondVertex, const TopoDS_Vertex &theThirdVertex)
 Constructs the angle display object defined by three vertices. More...
 
 AIS_AngleDimension (const TopoDS_Face &theCone)
 Constructs angle dimension for the cone face. More...
 
 AIS_AngleDimension (const TopoDS_Face &theFirstFace, const TopoDS_Face &theSecondFace)
 Constructs angle dimension between two planar faces. More...
 
 AIS_AngleDimension (const TopoDS_Face &theFirstFace, const TopoDS_Face &theSecondFace, const gp_Pnt &thePoint)
 Constructs angle dimension between two planar faces. More...
 
const gp_PntFirstPoint () const
 
const gp_PntSecondPoint () const
 
const gp_PntCenterPoint () const
 
const TopoDS_ShapeFirstShape () const
 
const TopoDS_ShapeSecondShape () const
 
const TopoDS_ShapeThirdShape () const
 
void SetMeasuredGeometry (const TopoDS_Edge &theFirstEdge, const TopoDS_Edge &theSecondEdge)
 Measures minimum angle dimension between two linear edges. These two edges should be intersected by each other. Otherwise the geometry is not valid. More...
 
void SetMeasuredGeometry (const gp_Pnt &theFirstPoint, const gp_Pnt &theSecondPoint, const gp_Pnt &theThridPoint)
 Measures angle defined by three points. More...
 
void SetMeasuredGeometry (const TopoDS_Vertex &theFirstVertex, const TopoDS_Vertex &theSecondVertex, const TopoDS_Vertex &theThirdVertex)
 Measures angle defined by three vertices. More...
 
void SetMeasuredGeometry (const TopoDS_Face &theCone)
 Measures angle of conical face. More...
 
void SetMeasuredGeometry (const TopoDS_Face &theFirstFace, const TopoDS_Face &theSecondFace)
 Measures angle between two planar faces. More...
 
void SetMeasuredGeometry (const TopoDS_Face &theFirstFace, const TopoDS_Face &theSecondFace, const gp_Pnt &thePoint)
 Measures angle between two planar faces. More...
 
virtual const TCollection_AsciiStringGetDisplayUnits () const override
 
virtual const TCollection_AsciiStringGetModelUnits () const override
 
virtual void SetDisplayUnits (const TCollection_AsciiString &theUnits) override
 
virtual void SetModelUnits (const TCollection_AsciiString &theUnits) override
 
virtual void SetTextPosition (const gp_Pnt &theTextPos) override
 Principle of horizontal text alignment settings: More...
 
virtual const gp_Pnt GetTextPosition () const override
 Computes absolute text position from dimension parameters (flyout, plane and text alignment). More...
 
void SetType (const AIS_TypeOfAngle theType)
 Sets angle type. More...
 
AIS_TypeOfAngle GetType () const
 
void SetArrowsVisibility (const AIS_TypeOfAngleArrowVisibility &theType)
 Sets visible arrows type. More...
 
AIS_TypeOfAngleArrowVisibility GetArrowsVisibility () const
 
- Public Member Functions inherited from AIS_Dimension
 AIS_Dimension (const AIS_KindOfDimension theType)
 Constructor with default parameters values. More...
 
Standard_Real GetValue () const
 Gets dimension measurement value. If the value to display is not specified by user, then the dimension object is responsible to compute it on its own in model space coordinates. More...
 
void SetComputedValue ()
 Sets computed dimension value. Resets custom value mode if it was set. More...
 
void SetCustomValue (const Standard_Real theValue)
 Sets user-defined dimension value. The user-defined dimension value is specified in model space, and affect by unit conversion during the display. More...
 
void SetCustomValue (const TCollection_ExtendedString &theValue)
 Sets user-defined dimension value. Unit conversion during the display is not applyed. More...
 
const TCollection_ExtendedStringGetCustomValue () const
 Gets user-defined dimension value. More...
 
const gp_PlnGetPlane () const
 Get the dimension plane in which the 2D dimension presentation is computed. By default, if plane is not defined by user, it is computed automatically after dimension geometry is computed. If computed dimension geometry (points) can't be placed on the user-defined plane, dimension geometry was set as invalid (validity flag is set to false) and dimension presentation will not be computed. If user-defined plane allow geometry placement on it, it will be used for computing of the dimension presentation. More...
 
Standard_Integer GetGeometryType () const
 Geometry type defines type of shapes on which the dimension is to be built. More...
 
virtual void SetCustomPlane (const gp_Pln &thePlane)
 Sets user-defined plane where the 2D dimension presentation will be placed. Checks validity of this plane if geometry has been set already. Validity of the plane is checked according to the geometry set and has different criteria for different kinds of dimensions. More...
 
void UnsetCustomPlane ()
 Unsets user-defined plane. Therefore the plane for dimension will be computed automatically. More...
 
Standard_Boolean IsTextPositionCustom () const
 
Handle< Prs3d_DimensionAspectDimensionAspect () const
 Gets the dimension aspect from AIS object drawer. Dimension aspect contains aspects of line, text and arrows for dimension presentation. More...
 
void SetDimensionAspect (const Handle< Prs3d_DimensionAspect > &theDimensionAspect)
 Sets new dimension aspect for the interactive object drawer. The dimension aspect provides dynamic properties which are generally used during computation of dimension presentations. More...
 
AIS_KindOfDimension KindOfDimension () const
 
virtual AIS_KindOfInteractive Type () const override
 
virtual Standard_Boolean AcceptDisplayMode (const Standard_Integer theMode) const override
 Returns true if the class of objects accepts the display mode theMode. The interactive context can have a default mode of representation for the set of Interactive Objects. This mode may not be accepted by object. More...
 
AIS_DisplaySpecialSymbol DisplaySpecialSymbol () const
 
void SetDisplaySpecialSymbol (const AIS_DisplaySpecialSymbol theDisplaySpecSymbol)
 Specifies whether to display special symbol or not. More...
 
Standard_ExtCharacter SpecialSymbol () const
 
void SetSpecialSymbol (const Standard_ExtCharacter theSpecialSymbol)
 Specifies special symbol. More...
 
void UnsetFixedTextPosition ()
 Unsets user defined text positioning and enables text positioning by other parameters: text alignment, extension size, flyout and custom plane. More...
 
Standard_Real SelToleranceForText2d () const
 Returns selection tolerance for text2d: For 2d text selection detection sensitive point with tolerance is used Important! Only for 2d text. More...
 
void SetSelToleranceForText2d (const Standard_Real theTol)
 Sets selection tolerance for text2d: For 2d text selection detection sensitive point with tolerance is used to change this tolerance use this method Important! Only for 2d text. More...
 
Standard_Real GetFlyout () const
 
void SetFlyout (const Standard_Real theFlyout)
 Sets flyout value for dimension. More...
 
virtual Standard_Boolean IsValid () const
 Check that the input geometry for dimension is valid and the presentation can be successfully computed. More...
 
- Public Member Functions inherited from AIS_InteractiveObject
virtual Standard_Integer Signature () const
 Specifies additional characteristics of Interactive Objects. A signature is, in fact, an index with integer values assigned different properties. This method is frequently used in conjuction with Type to give a particular type and signature to an Interactive Object. By default, the Interactive Object has a None type and a signature of 0. Among the datums, this signature is attributed to the shape The remaining datums have the following default signatures: More...
 
virtual Standard_Boolean AcceptShapeDecomposition () const
 Informs the graphic context that the interactive Object may be decomposed into sub-shapes for dynamic selection. The most used Interactive Object is AIS_Shape. Activation methods for standard selection modes are proposed in the Interactive Context. These include selection by vertex or by edges. For datums with the same behavior as AIS_Shape, such as vetices and edges, we must redefine the virtual method so that AcceptShapeDecomposition returns false. Rule for selection : Mode 0 : Selection of the interactive Object itself Mode 1 : Selection of vertices Mode 2 : Selection Of Edges Mode 3 : Selection Of Wires Mode 4 : Selection Of Faces ... More...
 
void SetCurrentFacingModel (const Aspect_TypeOfFacingModel aModel=Aspect_TOFM_BOTH_SIDE)
 change the current facing model apply on polygons for SetColor(), SetTransparency(), SetMaterial() methods default facing model is Aspect_TOFM_TWO_SIDE. This mean that attributes is applying both on the front and back face. More...
 
Aspect_TypeOfFacingModel CurrentFacingModel () const
 Returns the current facing model which is in effect. More...
 
virtual void SetColor (const Quantity_Color &theColor)
 Only the interactive object knowns which Drawer attribute is affected by the color, if any (ex: for a wire,it's the wireaspect field of the drawer, but for a vertex, only the point aspect field is affected by the color). WARNING : Do not forget to set the corresponding fields here (hasOwnColor and myDrawer->SetColor()) More...
 
virtual void UnsetColor ()
 Removes color settings. Only the Interactive Object knows which Drawer attribute is affected by the color setting. For a wire, for example, wire aspect is the attribute affected. For a vertex, however, only point aspect is affected by the color setting. More...
 
virtual void SetWidth (const Standard_Real aValue)
 Allows you to provide the setting aValue for width. Only the Interactive Object knows which Drawer attribute is affected by the width setting. More...
 
virtual void UnsetWidth ()
 
virtual Standard_Integer DefaultDisplayMode () const
 Returns the default display mode. This method is to be implemented when the main mode is not mode 0. More...
 
void Redisplay (const Standard_Boolean AllModes=Standard_False)
 Updates the active presentation; if <AllModes> = Standard_True all the presentations inside are recomputed. IMPORTANT: It is preferable to call Redisplay method of corresponding AIS_InteractiveContext instance for cases when it is accessible. This method just redirects call to myCTXPtr, so this class field must be up to date for proper result. More...
 
void SetInfiniteState (const Standard_Boolean aFlag=Standard_True)
 Sets the infinite state flag aFlage. if <aFlag> = True , the interactiveObject is considered as infinite, i.e. its graphic presentations are not taken in account for View FitAll... More...
 
Standard_Boolean IsInfinite () const
 Returns true if the interactive object is infinite. In this case, its graphic presentations are not taken into account in the fit-all view. More...
 
Standard_Boolean HasInteractiveContext () const
 Indicates whether the Interactive Object has a pointer to an interactive context. More...
 
Handle< AIS_InteractiveContextGetContext () const
 Returns the context pointer to the interactive context. More...
 
virtual void SetContext (const Handle< AIS_InteractiveContext > &aCtx)
 Sets the interactive context aCtx and provides a link to the default drawing tool or "Drawer" if there is none. More...
 
Standard_Boolean HasOwner () const
 Returns true if the object has an owner attributed to it. The owner can be a shape for a set of sub-shapes or a sub-shape for sub-shapes which it is composed of, and takes the form of a transient. More...
 
const Handle< Standard_Transient > & GetOwner () const
 Returns the owner of the Interactive Object. The owner can be a shape for a set of sub-shapes or a sub-shape for sub-shapes which it is composed of, and takes the form of a transient. There are two types of owners: More...
 
void SetOwner (const Handle< Standard_Transient > &theApplicativeEntity)
 Allows you to attribute the owner theApplicativeEntity to an Interactive Object. This can be a shape for a set of sub-shapes or a sub-shape for sub-shapes which it is composed of. The owner takes the form of a transient. More...
 
void ClearOwner ()
 Each Interactive Object has methods which allow us to attribute an Owner to it in the form of a Transient. This method removes the owner from the graphic entity. More...
 
Standard_Boolean HasDisplayMode () const
 Returns true if the Interactive Object has a display mode setting. Otherwise, it is displayed in Neutral Point. More...
 
void SetDisplayMode (const Standard_Integer aMode)
 Sets the display mode aMode for the interactive object. An object can have its own temporary display mode, which is different from that proposed by the interactive context. The range of possibilities currently proposed is the following: More...
 
void UnsetDisplayMode ()
 Removes display mode settings from the interactive object. More...
 
Standard_Integer DisplayMode () const
 Returns the display mode setting of the Interactive Object. The range of possibilities is the following: More...
 
Standard_Boolean HasHilightMode () const
 Returns true if the Interactive Object is in highlight mode. More...
 
Standard_Integer HilightMode () const
 Returns highlight display mode. This is obsolete method for backward compatibility - use ::HilightAttributes() and ::DynamicHilightAttributes() instead. More...
 
void SetHilightMode (const Standard_Integer theMode)
 Sets highlight display mode. This is obsolete method for backward compatibility - use ::HilightAttributes() and ::DynamicHilightAttributes() instead. More...
 
void UnsetHilightMode ()
 Unsets highlight display mode. More...
 
Standard_Boolean HasColor () const
 Returns true if the Interactive Object has color. More...
 
virtual void Color (Quantity_Color &theColor) const
 Returns the color setting of the Interactive Object. More...
 
Standard_Boolean HasWidth () const
 Returns true if the Interactive Object has width. More...
 
Standard_Real Width () const
 Returns the width setting of the Interactive Object. More...
 
Standard_Boolean HasMaterial () const
 Returns true if the Interactive Object has a setting for material. More...
 
virtual Graphic3d_NameOfMaterial Material () const
 Returns the current material setting. This will be on of the following materials: More...
 
virtual void SetMaterial (const Graphic3d_MaterialAspect &aName)
 Sets the material aMat defining this display attribute for the interactive object. Material aspect determines shading aspect, color and transparency of visible entities. More...
 
virtual void UnsetMaterial ()
 Removes the setting for material. More...
 
virtual void SetTransparency (const Standard_Real aValue=0.6)
 Attributes a setting aValue for transparency. The transparency value should be between 0.0 and 1.0. At 0.0 an object will be totally opaque, and at 1.0, fully transparent. Warning At a value of 1.0, there may be nothing visible. More...
 
Standard_Boolean IsTransparent () const
 Returns true if there is a transparency setting. More...
 
virtual Standard_Real Transparency () const
 Returns the transparency setting. This will be between 0.0 and 1.0. At 0.0 an object will be totally opaque, and at 1.0, fully transparent. More...
 
virtual void UnsetTransparency ()
 Removes the transparency setting. The object is opaque by default. More...
 
virtual void UnsetAttributes () override
 Clears settings provided by the drawing tool aDrawer. More...
 
Standard_Boolean HasPresentation () const
 Returns TRUE when this object has a presentation in the current DisplayMode() More...
 
Handle< Prs3d_PresentationPresentation () const
 Returns the current presentation of this object according to the current DisplayMode() More...
 
void SetAspect (const Handle< Prs3d_BasicAspect > &anAspect)
 Sets the graphic basic aspect to the current presentation. More...
 
virtual void SetPolygonOffsets (const Standard_Integer aMode, const Standard_ShortReal aFactor=1.0, const Standard_ShortReal aUnits=0.0)
 Sets up polygon offsets for this object. It modifies all existing presentations of <anObj> (if any), so it is reasonable to call this method after <anObj> has been displayed. Otherwise, Compute() method should pass Graphic3d_AspectFillArea3d aspect from <myDrawer> to Graphic3d_Group to make polygon offsets work. More...
 
virtual Standard_Boolean HasPolygonOffsets () const
 Returns Standard_True if <myDrawer> has non-null shading aspect. More...
 
virtual void PolygonOffsets (Standard_Integer &aMode, Standard_ShortReal &aFactor, Standard_ShortReal &aUnits) const
 Retrieves current polygon offsets settings from <myDrawer>. More...
 
virtual void BoundingBox (Bnd_Box &theBndBox) override
 Returns bounding box of object correspondingly to its current display mode. More...
 
void SetIsoOnTriangulation (const Standard_Boolean theIsEnabled)
 Enables or disables on-triangulation build of isolines according to the flag given. More...
 
void SynchronizeAspects ()
 Synchronize presentation aspects after their modification. More...
 
- Public Member Functions inherited from SelectMgr_SelectableObject
virtual ~SelectMgr_SelectableObject ()
 Clears all selections of the object. More...
 
void RecomputePrimitives ()
 Re-computes the sensitive primitives for all modes. IMPORTANT: Do not use this method to update selection primitives except implementing custom selection manager! This method does not take into account necessary BVH updates, but may invalidate the pointers it refers to. TO UPDATE SELECTION properly from outside classes, use method UpdateSelection. More...
 
void RecomputePrimitives (const Standard_Integer theMode)
 Re-computes the sensitive primitives which correspond to the <theMode>th selection mode. IMPORTANT: Do not use this method to update selection primitives except implementing custom selection manager! selection manager! This method does not take into account necessary BVH updates, but may invalidate the pointers it refers to. TO UPDATE SELECTION properly from outside classes, use method UpdateSelection. More...
 
void AddSelection (const Handle< SelectMgr_Selection > &aSelection, const Standard_Integer aMode)
 Adds the selection aSelection with the selection mode index aMode to this framework. More...
 
void ClearSelections (const Standard_Boolean update=Standard_False)
 Empties all the selections in the SelectableObject <update> parameter defines whether all object's selections should be flagged for further update or not. This improved method can be used to recompute an object's selection (without redisplaying the object completely) when some selection mode is activated not for the first time. More...
 
const Handle< SelectMgr_Selection > & Selection (const Standard_Integer theMode) const
 Returns the selection having specified selection mode or NULL. More...
 
Standard_Boolean HasSelection (const Standard_Integer theMode) const
 Returns true if a selection corresponding to the selection mode theMode was computed for this object. More...
 
const SelectMgr_SequenceOfSelectionSelections () const
 Return the sequence of selections. More...
 
void Init ()
 Begins the iteration scanning for sensitive primitives. More...
 
Standard_Boolean More () const
 Continues the iteration scanning for sensitive primitives. More...
 
void Next ()
 Continues the iteration scanning for sensitive primitives. More...
 
const Handle< SelectMgr_Selection > & CurrentSelection () const
 Returns the current selection in this framework. More...
 
void ResetTransformation () override
 resets local transformation to identity. More...
 
virtual void UpdateTransformation () override
 Recomputes the location of the selection aSelection. More...
 
virtual void UpdateTransformations (const Handle< SelectMgr_Selection > &aSelection)
 Updates locations in all sensitive entities from <aSelection> and in corresponding entity owners. More...
 
virtual void HilightSelected (const Handle< PrsMgr_PresentationManager3d > &PM, const SelectMgr_SequenceOfOwner &Seq)
 Method which draws selected owners ( for fast presentation draw ) More...
 
virtual void ClearSelected ()
 Method which clear all selected owners belonging to this selectable object ( for fast presentation draw ) More...
 
virtual void ClearDynamicHighlight (const Handle< PrsMgr_PresentationManager3d > &theMgr)
 Method that needs to be implemented when the object manages selection and dynamic highlighting on its own. Clears or invalidates dynamic highlight presentation. By default it clears immediate draw of given presentation manager. More...
 
virtual void HilightOwnerWithColor (const Handle< PrsMgr_PresentationManager3d > &thePM, const Handle< Prs3d_Drawer > &theStyle, const Handle< SelectMgr_EntityOwner > &theOwner)
 Method which hilight an owner belonging to this selectable object ( for fast presentation draw ) More...
 
virtual Standard_Boolean IsAutoHilight () const
 If returns True, the old mechanism for highlighting selected objects is used (HilightSelected Method may be empty). If returns False, the HilightSelected method will be fully responsible for highlighting selected entity owners belonging to this selectable object. More...
 
virtual void SetAutoHilight (const Standard_Boolean newAutoHilight)
 Set AutoHilight property to true or false Sets up Transform Persistence Mode for this object. More...
 
Handle< Prs3d_PresentationGetHilightPresentation (const Handle< PrsMgr_PresentationManager3d > &TheMgr)
 
Handle< Prs3d_PresentationGetSelectPresentation (const Handle< PrsMgr_PresentationManager3d > &TheMgr)
 
virtual void ErasePresentations (Standard_Boolean theToRemove)
 Removes presentations returned by GetHilightPresentation() and GetSelectPresentation(). More...
 
virtual void SetZLayer (const Graphic3d_ZLayerId theLayerId) override
 Set Z layer ID and update all presentations of the selectable object. The layers mechanism allows drawing objects in higher layers in overlay of objects in lower layers. More...
 
void UpdateSelection (const Standard_Integer theMode=-1)
 Sets update status FULL to selections of the object. Must be used as the only method of UpdateSelection from outer classes to prevent BVH structures from being outdated. More...
 
void SetAssemblyOwner (const Handle< SelectMgr_EntityOwner > &theOwner, const Standard_Integer theMode=-1)
 Sets common entity owner for assembly sensitive object entities. More...
 
Bnd_Box BndBoxOfSelected (const Handle< SelectMgr_IndexedMapOfOwner > &theOwners)
 Returns a bounding box of sensitive entities with the owners given if they are a part of activated selection. More...
 
Standard_Integer GlobalSelectionMode () const
 Returns the mode for selection of object as a whole. More...
 
virtual Handle< SelectMgr_EntityOwnerGlobalSelOwner () const
 Returns the owner of mode for selection of object as a whole. More...
 
virtual const Handle< SelectMgr_EntityOwner > & GetAssemblyOwner () const
 Returns common entity owner if the object is an assembly. More...
 
- Public Member Functions inherited from PrsMgr_PresentableObject
PrsMgr_PresentationsPresentations ()
 
PrsMgr_TypeOfPresentation3d TypeOfPresentation3d () const
 Returns information on whether the object accepts display in HLR mode or not. More...
 
const Handle< Graphic3d_TransformPers > & TransformPersistence () const
 Returns Transformation Persistence defining a special Local Coordinate system where this presentable object is located or NULL handle if not defined. Position of the object having Transformation Persistence is mutable and depends on camera position. The same applies to a bounding box of the object. More...
 
virtual void SetTransformPersistence (const Handle< Graphic3d_TransformPers > &theTrsfPers)
 Sets up Transform Persistence defining a special Local Coordinate system where this object should be located. Note that management of Transform Persistence object is more expensive than of the normal one, because it requires its position being recomputed basing on camera position within each draw call / traverse. More...
 
void SetTransformPersistence (const Graphic3d_TransModeFlags theMode, const gp_Pnt &thePoint=gp_Pnt(0.0, 0.0, 0.0))
 Sets up Transform Persistence Mode for this object. This function used to lock in object position, rotation and / or zooming relative to camera position. Object will be drawn in the origin setted by thePoint parameter (except Graphic3d_TMF_TriedronPers flag. More...
 
Graphic3d_TransModeFlags GetTransformPersistenceMode () const
 Gets Transform Persistence Mode for this object. More...
 
gp_Pnt GetTransformPersistencePoint () const
 Gets point of transform persistence for this object. More...
 
void SetTypeOfPresentation (const PrsMgr_TypeOfPresentation3d aType)
 
Standard_Boolean ToBeUpdated (Standard_Boolean theToIncludeHidden=Standard_False) const
 Returns TRUE if any active presentation has invalidation flag. More...
 
void SetToUpdate (Standard_Integer theMode)
 Flags presentation to be updated; UpdatePresentations() will recompute these presentations. More...
 
void SetToUpdate ()
 flags all the Presentations to be Updated. More...
 
void ToBeUpdated (TColStd_ListOfInteger &ListOfMode) const
 gives the list of modes which are flagged "to be updated". More...
 
const Handle< Geom_Transformation > & LocalTransformationGeom () const
 Return the local transformation. Note that the local transformation of the object having Transformation Persistence is applied within Local Coordinate system defined by this Persistence. More...
 
void SetLocalTransformation (const gp_Trsf &theTrsf)
 Sets local transformation to theTransformation. Note that the local transformation of the object having Transformation Persistence is applied within Local Coordinate system defined by this Persistence. More...
 
void SetLocalTransformation (const Handle< Geom_Transformation > &theTrsf)
 Sets local transformation to theTransformation. Note that the local transformation of the object having Transformation Persistence is applied within Local Coordinate system defined by this Persistence. More...
 
Standard_Boolean HasTransformation () const
 Returns true if object has a transformation that is different from the identity. More...
 
const Handle< Geom_Transformation > & TransformationGeom () const
 Return the transformation taking into account transformation of parent object(s). Note that the local transformation of the object having Transformation Persistence is applied within Local Coordinate system defined by this Persistence. More...
 
const gp_TrsfLocalTransformation () const
 Return the local transformation. Note that the local transformation of the object having Transformation Persistence is applied within Local Coordinate system defined by this Persistence. More...
 
const gp_TrsfTransformation () const
 Return the transformation taking into account transformation of parent object(s). Note that the local transformation of the object having Transformation Persistence is applied within Local Coordinate system defined by this Persistence. More...
 
const gp_GTrsfInversedTransformation () const
 
Graphic3d_ZLayerId ZLayer () const
 Get ID of Z layer. More...
 
virtual void AddClipPlane (const Handle< Graphic3d_ClipPlane > &thePlane)
 Adds clip plane for graphical clipping for all display mode presentations. The composition of clip planes truncates the rendering space to convex volume. Please be aware that number of supported clip plane is limited. The planes which exceed the limit are ignored. Besides of this, some planes can be already set in view where the object is shown: the number of these planes should be substracted from limit to predict the maximum possible number of object clipping planes. More...
 
virtual void RemoveClipPlane (const Handle< Graphic3d_ClipPlane > &thePlane)
 Removes previously added clip plane. More...
 
virtual void SetClipPlanes (const Handle< Graphic3d_SequenceOfHClipPlane > &thePlanes)
 Set clip planes for graphical clipping for all display mode presentations. The composition of clip planes truncates the rendering space to convex volume. Please be aware that number of supported clip plane is limited. The planes which exceed the limit are ignored. Besides of this, some planes can be already set in view where the object is shown: the number of these planes should be subtracted from limit to predict the maximum possible number of object clipping planes. More...
 
void SetClipPlanes (const Graphic3d_SequenceOfHClipPlane &thePlanes)
 
const Handle< Graphic3d_SequenceOfHClipPlane > & ClipPlanes () const
 Get clip planes. More...
 
virtual void SetMutable (const Standard_Boolean theIsMutable)
 Sets if the object has mutable nature (content or location will be changed regularly). This method should be called before object displaying to take effect. More...
 
Standard_Boolean IsMutable () const
 Returns true if object has mutable nature (content or location are be changed regularly). Mutable object will be managed in different way than static onces (another optimizations). More...
 
virtual void AddChild (const Handle< PrsMgr_PresentableObject > &theObject)
 Makes theObject child of current object in scene hierarchy. More...
 
virtual void RemoveChild (const Handle< PrsMgr_PresentableObject > &theObject)
 Removes theObject from children of current object in scene hierarchy. More...
 
const PrsMgr_ListOfPresentableObjectsChildren () const
 Returns children of the current object. More...
 
Standard_Boolean HasOwnPresentations () const
 Returns true if object should have own presentations. More...
 
PrsMgr_PresentableObjectPointer Parent () const
 Returns parent of current object in scene hierarchy. More...
 
virtual void SetAttributes (const Handle< Prs3d_Drawer > &theDrawer)
 Initializes the drawing tool theDrawer. More...
 
const Handle< Prs3d_Drawer > & Attributes () const
 Returns the attributes settings. More...
 
const Handle< Prs3d_Drawer > & HilightAttributes () const
 Returns the hilight attributes settings. When not NULL, overrides both Prs3d_TypeOfHighlight_LocalSelected and Prs3d_TypeOfHighlight_Selected defined within AIS_InteractiveContext. More...
 
virtual void SetHilightAttributes (const Handle< Prs3d_Drawer > &theDrawer)
 Initializes the hilight drawing tool theDrawer. More...
 
const Handle< Prs3d_Drawer > & DynamicHilightAttributes () const
 Returns the hilight attributes settings. When not NULL, overrides both Prs3d_TypeOfHighlight_LocalDynamic and Prs3d_TypeOfHighlight_Dynamic defined within AIS_InteractiveContext. More...
 
virtual void SetDynamicHilightAttributes (const Handle< Prs3d_Drawer > &theDrawer)
 Initializes the dynamic hilight drawing tool. More...
 
virtual void UnsetHilightAttributes ()
 Clears settings provided by the hilight drawing tool theDrawer. More...
 
- Public Member Functions inherited from Standard_Transient
 Standard_Transient ()
 Empty constructor. More...
 
 Standard_Transient (const Standard_Transient &)
 Copy constructor – does nothing. More...
 
Standard_Transientoperator= (const Standard_Transient &)
 Assignment operator, needed to avoid copying reference counter. More...
 
virtual ~Standard_Transient ()
 Destructor must be virtual. More...
 
virtual void Delete () const
 Memory deallocator for transient classes. More...
 
virtual const opencascade::handle< Standard_Type > & DynamicType () const
 Returns a type descriptor about this object. More...
 
Standard_Boolean IsInstance (const opencascade::handle< Standard_Type > &theType) const
 Returns a true value if this is an instance of Type. More...
 
Standard_Boolean IsInstance (const Standard_CString theTypeName) const
 Returns a true value if this is an instance of TypeName. More...
 
Standard_Boolean IsKind (const opencascade::handle< Standard_Type > &theType) const
 Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
 
Standard_Boolean IsKind (const Standard_CString theTypeName) const
 Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
 
Standard_TransientThis () const
 Returns non-const pointer to this object (like const_cast). For protection against creating handle to objects allocated in stack or call from constructor, it will raise exception Standard_ProgramError if reference counter is zero. More...
 
Standard_Integer GetRefCount () const
 Get the reference counter of this object. More...
 
void IncrementRefCounter () const
 Increments the reference counter of this object. More...
 
Standard_Integer DecrementRefCounter () const
 Decrements the reference counter of this object; returns the decremented value. More...
 

Protected Member Functions

void Init ()
 Initialization of fields that is common to all constructors. More...
 
gp_Dir GetNormalForMinAngle () const
 Gets plane normal for minimal angle. Dimension computation is based on three attach points and plane normal. Based on this normal angle arc, arrows and extensions are constructed. More...
 
gp_Pnt GetCenterOnArc (const gp_Pnt &theFirstAttach, const gp_Pnt &theSecondAttach, const gp_Pnt &theCenter) const
 
void DrawArc (const Handle< Prs3d_Presentation > &thePresentation, const gp_Pnt &theFirstAttach, const gp_Pnt &theSecondAttach, const gp_Pnt &theCenter, const Standard_Real theRadius, const Standard_Integer theMode)
 Draws main dimension line (arc). More...
 
void DrawArcWithText (const Handle< Prs3d_Presentation > &thePresentation, const gp_Pnt &theFirstAttach, const gp_Pnt &theSecondAttach, const gp_Pnt &theCenter, const TCollection_ExtendedString &theText, const Standard_Real theTextWidth, const Standard_Integer theMode, const Standard_Integer theLabelPosition)
 Draws main dimension line (arc) with text. More...
 
void FitTextAlignment (const Prs3d_DimensionTextHorizontalPosition &theHorizontalTextPos, Standard_Integer &theLabelPosition, Standard_Boolean &theIsArrowsExternal) const
 Fits text alignment relatively to the dimension line; it computes the value of label position and arrow orientation according set in the aspect and dimension properties. More...
 
void AdjustParameters (const gp_Pnt &theTextPos, Standard_Real &theExtensionSize, Prs3d_DimensionTextHorizontalPosition &theAlignment, Standard_Real &theFlyout) const
 Adjusts aspect parameters according the text position: extension size, vertical text alignment and flyout. More...
 
virtual void ComputePlane ()
 
virtual Standard_Boolean CheckPlane (const gp_Pln &thePlane) const override
 Checks if the plane includes three angle points to build dimension. More...
 
virtual Standard_Real ComputeValue () const override
 Override this method to computed value of dimension. More...
 
virtual void Compute (const Handle< PrsMgr_PresentationManager3d > &thePM, const Handle< Prs3d_Presentation > &thePresentation, const Standard_Integer theMode=0) override
 Calculates the 3D view aPresentation and its updates. The latter are managed by aPresentationManager. aPresentableObject has the display mode aMode; this has the default value of 0, that is, the wireframe display mode. More...
 
virtual void ComputeFlyoutSelection (const Handle< SelectMgr_Selection > &theSelection, const Handle< SelectMgr_EntityOwner > &theOwner) override
 Override this method to compute selection primitives for flyout lines (if the dimension provides it). This callback is a only a part of base selection computation routine. More...
 
Standard_Boolean InitTwoEdgesAngle (gp_Pln &theComputedPlane)
 Init angular dimension to measure angle between two linear edges. More...
 
Standard_Boolean InitTwoFacesAngle ()
 Init angular dimension to measure angle between two planar faces. there is no user-defined poisitoning. So attach points are set according to faces geometry (in origin of the first face basis surface). More...
 
Standard_Boolean InitTwoFacesAngle (const gp_Pnt thePointOnFirstFace)
 Init angular dimension to measure angle between two planar faces. More...
 
Standard_Boolean InitConeAngle ()
 Init angular dimension to measure cone face. More...
 
Standard_Boolean IsValidPoints (const gp_Pnt &theFirstPoint, const gp_Pnt &theCenterPoint, const gp_Pnt &theSecondPoint) const
 Check that the points forming angle are valid. More...
 
Standard_Boolean isArrowVisible (const AIS_TypeOfAngleArrowVisibility &theArrowType) const
 Returns true if the arrow should be visible. More...
 
- Protected Member Functions inherited from AIS_Dimension
Standard_Real ValueToDisplayUnits () const
 
TCollection_ExtendedString GetValueString (Standard_Real &theWidth) const
 Get formatted value string and its model space width. More...
 
void DrawArrow (const Handle< Prs3d_Presentation > &thePresentation, const gp_Pnt &theLocation, const gp_Dir &theDirection)
 Performs drawing of 2d or 3d arrows on the working plane. More...
 
void drawText (const Handle< Prs3d_Presentation > &thePresentation, const gp_Pnt &theTextPos, const gp_Dir &theTextDir, const TCollection_ExtendedString &theText, const Standard_Integer theLabelPosition)
 Performs drawing of 2d or 3d text on the working plane. More...
 
void DrawExtension (const Handle< Prs3d_Presentation > &thePresentation, const Standard_Real theExtensionSize, const gp_Pnt &theExtensionStart, const gp_Dir &theExtensionDir, const TCollection_ExtendedString &theLabelString, const Standard_Real theLabelWidth, const Standard_Integer theMode, const Standard_Integer theLabelPosition)
 Performs computing of dimension linear extension with text. More...
 
void DrawLinearDimension (const Handle< Prs3d_Presentation > &thePresentation, const Standard_Integer theMode, const gp_Pnt &theFirstPoint, const gp_Pnt &theSecondPoint, const Standard_Boolean theIsOneSide=Standard_False)
 Performs computing of linear dimension (for length, diameter, radius and so on). Please note that this method uses base dimension properties, like working plane flyout length, drawer attributes. More...
 
virtual void ComputeFlyoutLinePoints (const gp_Pnt &theFirstPoint, const gp_Pnt &theSecondPoint, gp_Pnt &theLineBegPoint, gp_Pnt &theLineEndPoint)
 Computes points bounded the flyout line for linear dimension. More...
 
void ComputeLinearFlyouts (const Handle< SelectMgr_Selection > &theSelection, const Handle< SelectMgr_EntityOwner > &theOwner, const gp_Pnt &theFirstPoint, const gp_Pnt &theSecondPoint)
 Compute selection sensitives for linear dimension flyout lines (length, diameter, radius). Please note that this method uses base dimension properties: working plane and flyout length. More...
 
Standard_Boolean InitCircularDimension (const TopoDS_Shape &theShape, gp_Circ &theCircle, gp_Pnt &theMiddleArcPoint, Standard_Boolean &theIsClosed)
 Performs initialization of circle and middle arc point from the passed shape which is assumed to contain circular geometry. More...
 
void PointsForArrow (const gp_Pnt &thePeakPnt, const gp_Dir &theDirection, const gp_Dir &thePlane, const Standard_Real theArrowLength, const Standard_Real theArrowAngle, gp_Pnt &theSidePnt1, gp_Pnt &theSidePnt2)
 Produce points for triangular arrow face. More...
 
gp_Pnt GetTextPositionForLinear (const gp_Pnt &theFirstPoint, const gp_Pnt &theSecondPoint, const Standard_Boolean theIsOneSide=Standard_False) const
 Compute point of text position for dimension parameters for linear kinds of dimensions (length, radius, diameter). More...
 
void FitTextAlignmentForLinear (const gp_Pnt &theFirstPoint, const gp_Pnt &theSecondPoint, const Standard_Boolean theIsOneSide, const Prs3d_DimensionTextHorizontalPosition &theHorizontalTextPos, Standard_Integer &theLabelPosition, Standard_Boolean &theIsArrowsExternal) const
 Fits text alignment relatively to the dimension line. More...
 
Standard_Boolean AdjustParametersForLinear (const gp_Pnt &theTextPos, const gp_Pnt &theFirstPoint, const gp_Pnt &theSecondPoint, Standard_Real &theExtensionSize, Prs3d_DimensionTextHorizontalPosition &theAlignment, Standard_Real &theFlyout, gp_Pln &thePlane, Standard_Boolean &theIsPlaneOld) const
 Adjusts aspect parameters according the text position: extension size, vertical text alignment and flyout. More...
 
virtual void ComputeSelection (const Handle< SelectMgr_Selection > &theSelection, const Standard_Integer theMode) override
 Base procedure of computing selection (based on selection geometry data). More...
 
- Protected Member Functions inherited from AIS_InteractiveObject
void replaceAspects (const Graphic3d_MapOfAspectsToAspects &theMap)
 Replace aspects of existing (computed) presentation groups, so that the new aspects can be applied without recomputing presentation. It is NOT recommended approach, because user has to fill such map and then search for each occurrence in computed groups. The recommended approach is computing presentation with necessary customized aspects, and then modify them directly followed by SynchronizeAspects() call. More...
 
 AIS_InteractiveObject (const PrsMgr_TypeOfPresentation3d aTypeOfPresentation3d=PrsMgr_TOP_AllView)
 The TypeOfPresention3d means that the interactive object may have a presentation dependant of the view of Display. More...
 
- Protected Member Functions inherited from SelectMgr_SelectableObject
 SelectMgr_SelectableObject (const PrsMgr_TypeOfPresentation3d aTypeOfPresentation3d=PrsMgr_TOP_AllView)
 
void setGlobalSelMode (const Standard_Integer theMode)
 
virtual void UpdateClipping () override
 Update clipping planes state. More...
 
virtual void updateSelection (const Standard_Integer theMode)
 
- Protected Member Functions inherited from PrsMgr_PresentableObject
 PrsMgr_PresentableObject (const PrsMgr_TypeOfPresentation3d aTypeOfPresentation3d=PrsMgr_TOP_AllView)
 
virtual ~PrsMgr_PresentableObject ()
 
virtual void Compute (const Handle< Prs3d_Projector > &aProjector, const Handle< Prs3d_Presentation > &aPresentation)
 Calculates the 3D view aPresentation and its updates. The latter are managed by aPresentationManager. Each of the views in the viewer and every modification such as rotation, for example, entails recalculation. It must be redefined to implement hidden line removal for the object. The user never calls this method himself. This is done via the InteractiveContext object and is dependent on the point of view from which the object is displayed. More...
 
virtual void Compute (const Handle< Prs3d_Projector > &aProjector, const Handle< Geom_Transformation > &aTrsf, const Handle< Prs3d_Presentation > &aPresentation)
 Calculates the 3D view aPresentation and its updates. The latter are managed by aPresentationManager. A point of view is provided by the projector aProjector, and the geometric transformation which has transformed associated presentable objects is specified by aTrsf. This function is to be used in case where a hidden line removal display cannot be calculated automatically. This occurs when associated presentable objects have been transformed geometrically, but not translated. Warning The transformation aTrsf must be applied to the object before computation. More...
 
Standard_Boolean UpdatePresentations (Standard_Boolean theToIncludeHidden=Standard_False)
 Recomputes invalidated presentations of the object. More...
 
void Update (Standard_Boolean theToIncludeHidden=Standard_False)
 Recomputes all presentations of the object. More...
 
void Update (Standard_Integer theMode, Standard_Boolean theToClearOther)
 Recomputes the presentation in the given mode. More...
 
virtual void Fill (const Handle< PrsMgr_PresentationManager > &aPresentationManager, const Handle< PrsMgr_Presentation > &aPresentation, const Standard_Integer aMode)
 High-level interface for controlling polygon offsets. More...
 
virtual void SetCombinedParentTransform (const Handle< Geom_Transformation > &theTrsf)
 Sets myCombinedParentTransform to theTransformation. Thus object receives transformation from parent node and able to derive its own. More...
 
virtual void setLocalTransformation (const Handle< Geom_Transformation > &theTransformation)
 Sets local transformation to theTransformation. More...
 
void recomputeComputed () const
 Recompute computed (HLR) presentations (when view is in computed mode). More...
 

Additional Inherited Members

- Public Types inherited from AIS_Dimension
enum  ComputeMode { ComputeMode_All = 0, ComputeMode_Line = 1, ComputeMode_Text = 2 }
 Specifies supported presentation compute modes. Used to compute only parts of presentation for advanced highlighting. More...
 
- Public Types inherited from Standard_Transient
typedef void base_type
 Returns a type descriptor about this object. More...
 
- Static Public Member Functions inherited from Standard_Transient
static const char * get_type_name ()
 Returns a type descriptor about this object. More...
 
static const opencascade::handle< Standard_Type > & get_type_descriptor ()
 Returns type descriptor of Standard_Transient class. More...
 
- Protected Types inherited from AIS_Dimension
enum  GeometryType {
  GeometryType_UndefShapes, GeometryType_Edge, GeometryType_Face, GeometryType_Points,
  GeometryType_Edges, GeometryType_Faces, GeometryType_EdgeFace, GeometryType_EdgeVertex
}
 Geometry type defines type of shapes on which the dimension is to be built. Some type of geometry allows automatic plane computing and can be built without user-defined plane Another types can't be built without user-defined plane. More...
 
enum  LabelPosition {
  LabelPosition_None = 0x00, LabelPosition_Left = 0x01, LabelPosition_Right = 0x02, LabelPosition_HCenter = 0x04,
  LabelPosition_HMask = LabelPosition_Left | LabelPosition_Right | LabelPosition_HCenter, LabelPosition_Above = 0x10, LabelPosition_Below = 0x20, LabelPosition_VCenter = 0x40,
  LabelPosition_VMask = LabelPosition_Above | LabelPosition_Below | LabelPosition_VCenter
}
 Specifies supported at base level horizontal and vertical label positions for drawing extension lines and centered text. More...
 
enum  ValueType { ValueType_Computed, ValueType_CustomReal, ValueType_CustomText }
 
- Static Protected Member Functions inherited from AIS_Dimension
static Standard_Boolean CircleFromPlanarFace (const TopoDS_Face &theFace, Handle< Geom_Curve > &theCurve, gp_Pnt &theFirstPoint, gp_Pnt &theLastPoint)
 If it is possible extracts circle from planar face. More...
 
static Standard_Boolean CircleFromEdge (const TopoDS_Edge &theEdge, gp_Circ &theCircle, gp_Pnt &theFirstPoint, gp_Pnt &theLastPoint)
 If it is possible extracts circle from the edge. More...
 
- Protected Attributes inherited from AIS_Dimension
struct AIS_Dimension::SelectionGeometry mySelectionGeom
 Sensitive point tolerance for 2d text selection. More...
 
Standard_Real mySelToleranceForText2d
 Sensitive point tolerance for 2d text selection. More...
 
ValueType myValueType
 type of value (computed or user-defined) More...
 
Standard_Real myCustomValue
 type of value (computed or user-defined) More...
 
TCollection_ExtendedString myCustomStringValue
 Value of the dimension (computed or user-defined). More...
 
gp_Pnt myFixedTextPosition
 Stores text position fixed by user. More...
 
Standard_Boolean myIsTextPositionFixed
 Is the text label position fixed by user. More...
 
Standard_ExtCharacter mySpecialSymbol
 Special symbol. More...
 
AIS_DisplaySpecialSymbol myDisplaySpecialSymbol
 Special symbol display options. More...
 
GeometryType myGeometryType
 defines type of shapes on which the dimension is to be built. More...
 
gp_Pln myPlane
 Plane where dimension will be built (computed or user defined). More...
 
Standard_Boolean myIsPlaneCustom
 Is plane defined by user (otherwise it will be computed automatically). More...
 
Standard_Real myFlyout
 Flyout distance. More...
 
Standard_Boolean myIsGeometryValid
 Is dimension geometry properly defined. More...
 
- Protected Attributes inherited from AIS_InteractiveObject
AIS_InteractiveContextmyCTXPtr
 
Handle< Standard_TransientmyOwner
 
Standard_ShortReal myOwnWidth
 
Aspect_TypeOfFacingModel myCurrentFacingModel
 
Standard_Boolean myInfiniteState
 
Standard_Boolean hasOwnColor
 
Standard_Boolean hasOwnMaterial
 
- Protected Attributes inherited from SelectMgr_SelectableObject
SelectMgr_SequenceOfSelection myselections
 
Handle< Prs3d_PresentationmySelectionPrs
 
Handle< Prs3d_PresentationmyHilightPrs
 
Standard_Boolean myAutoHilight
 
- Protected Attributes inherited from PrsMgr_PresentableObject
PrsMgr_Presentations myPresentations
 
Handle< Graphic3d_SequenceOfHClipPlanemyClipPlanes
 
Handle< Prs3d_DrawermyDrawer
 
Handle< Prs3d_DrawermyHilightDrawer
 
Handle< Prs3d_DrawermyDynHilightDrawer
 
PrsMgr_TypeOfPresentation3d myTypeOfPresentation3d
 
Standard_Boolean myIsMutable
 
Standard_Boolean myHasOwnPresentations
 

Detailed Description

Angle dimension. Can be constructed:

In case of three points or two intersected edges the dimension plane (on which dimension presentation is built) can be computed uniquely as through three defined points can be built only one plane. Therefore, if user-defined plane differs from this one, the dimension can't be built.

In cases of two planes automatic plane by default is built on point of the origin of parametric space of the first face (the basis surface) so, that the working plane and two faces intersection forms minimal angle between the faces. User can define the other point which the dimension plane should pass through using the appropriate constructor. This point can lay on the one of the faces or not. Also user can define his own plane but it should pass through the three points computed on the geometry initialization step (when the constructor or SetMeasuredGeometry() method is called).

In case of the conical face the center point of the angle is the apex of the conical surface. The attachment points are points of the first and the last parameter of the basis circle of the cone.

Constructor & Destructor Documentation

◆ AIS_AngleDimension() [1/6]

AIS_AngleDimension::AIS_AngleDimension ( const TopoDS_Edge theFirstEdge,
const TopoDS_Edge theSecondEdge 
)

Constructs minimum angle dimension between two linear edges (where possible). These two edges should be intersected by each other. Otherwise the geometry is not valid.

Parameters
theFirstEdge[in] the first edge.
theSecondEdge[in] the second edge.

◆ AIS_AngleDimension() [2/6]

AIS_AngleDimension::AIS_AngleDimension ( const gp_Pnt theFirstPoint,
const gp_Pnt theSecondPoint,
const gp_Pnt theThirdPoint 
)

Constructs the angle display object defined by three points.

Parameters
theFirstPoint[in] the first point (point on first angle flyout).
theSecondPoint[in] the center point of angle dimension.
theThirdPoint[in] the second point (point on second angle flyout).

◆ AIS_AngleDimension() [3/6]

AIS_AngleDimension::AIS_AngleDimension ( const TopoDS_Vertex theFirstVertex,
const TopoDS_Vertex theSecondVertex,
const TopoDS_Vertex theThirdVertex 
)

Constructs the angle display object defined by three vertices.

Parameters
theFirstVertex[in] the first vertex (vertex for first angle flyout).
theSecondVertex[in] the center vertex of angle dimension.
theThirdPoint[in] the second vertex (vertex for second angle flyout).

◆ AIS_AngleDimension() [4/6]

AIS_AngleDimension::AIS_AngleDimension ( const TopoDS_Face theCone)

Constructs angle dimension for the cone face.

Parameters
theCone[in] the conical face.

◆ AIS_AngleDimension() [5/6]

AIS_AngleDimension::AIS_AngleDimension ( const TopoDS_Face theFirstFace,
const TopoDS_Face theSecondFace 
)

Constructs angle dimension between two planar faces.

Parameters
theFirstFace[in] the first face.
theSecondFace[in] the second face.

◆ AIS_AngleDimension() [6/6]

AIS_AngleDimension::AIS_AngleDimension ( const TopoDS_Face theFirstFace,
const TopoDS_Face theSecondFace,
const gp_Pnt thePoint 
)

Constructs angle dimension between two planar faces.

Parameters
theFirstFace[in] the first face.
theSecondFace[in] the second face.
thePoint[in] the point which the dimension plane should pass through. This point can lay on the one of the faces or not.

Member Function Documentation

◆ AdjustParameters()

void AIS_AngleDimension::AdjustParameters ( const gp_Pnt theTextPos,
Standard_Real theExtensionSize,
Prs3d_DimensionTextHorizontalPosition theAlignment,
Standard_Real theFlyout 
) const
protected

Adjusts aspect parameters according the text position: extension size, vertical text alignment and flyout.

Parameters
theTextPos[in] the user defined 3d point of text position.
theExtensionSize[out] the adjusted extension size.
theAlignment[out] the horizontal label alignment.
theFlyout[out] the adjusted value of flyout.

◆ CenterPoint()

const gp_Pnt& AIS_AngleDimension::CenterPoint ( ) const
inline
Returns
center point forming the angle.

◆ CheckPlane()

virtual Standard_Boolean AIS_AngleDimension::CheckPlane ( const gp_Pln thePlane) const
overrideprotectedvirtual

Checks if the plane includes three angle points to build dimension.

Reimplemented from AIS_Dimension.

◆ Compute()

virtual void AIS_AngleDimension::Compute ( const Handle< PrsMgr_PresentationManager3d > &  aPresentationManager,
const Handle< Prs3d_Presentation > &  aPresentation,
const Standard_Integer  aMode = 0 
)
overrideprotectedvirtual

Calculates the 3D view aPresentation and its updates. The latter are managed by aPresentationManager. aPresentableObject has the display mode aMode; this has the default value of 0, that is, the wireframe display mode.

Reimplemented from PrsMgr_PresentableObject.

◆ ComputeFlyoutSelection()

virtual void AIS_AngleDimension::ComputeFlyoutSelection ( const Handle< SelectMgr_Selection > &  ,
const Handle< SelectMgr_EntityOwner > &   
)
overrideprotectedvirtual

Override this method to compute selection primitives for flyout lines (if the dimension provides it). This callback is a only a part of base selection computation routine.

Reimplemented from AIS_Dimension.

◆ ComputePlane()

virtual void AIS_AngleDimension::ComputePlane ( )
protectedvirtual

◆ ComputeValue()

virtual Standard_Real AIS_AngleDimension::ComputeValue ( ) const
overrideprotectedvirtual

Override this method to computed value of dimension.

Returns
value from the measured geometry.

Reimplemented from AIS_Dimension.

◆ DrawArc()

void AIS_AngleDimension::DrawArc ( const Handle< Prs3d_Presentation > &  thePresentation,
const gp_Pnt theFirstAttach,
const gp_Pnt theSecondAttach,
const gp_Pnt theCenter,
const Standard_Real  theRadius,
const Standard_Integer  theMode 
)
protected

Draws main dimension line (arc).

Parameters
thePresentation[in] the dimension presentation.
theFirstAttach[in] the first attachment point.
theSecondAttach[in] the second attachment point.
theCenter[in] the center point (center point of the angle).
theRadius[in] the radius of the dimension arc.
theMode[in] the display mode.

◆ DrawArcWithText()

void AIS_AngleDimension::DrawArcWithText ( const Handle< Prs3d_Presentation > &  thePresentation,
const gp_Pnt theFirstAttach,
const gp_Pnt theSecondAttach,
const gp_Pnt theCenter,
const TCollection_ExtendedString theText,
const Standard_Real  theTextWidth,
const Standard_Integer  theMode,
const Standard_Integer  theLabelPosition 
)
protected

Draws main dimension line (arc) with text.

Parameters
thePresentation[in] the dimension presentation.
theFirstAttach[in] the first attachment point.
theSecondAttach[in] the second attachment point.
theCenter[in] the center point (center point of the angle).
theText[in] the text label string.
theTextWidth[in] the text label width.
theMode[in] the display mode.
theLabelPosition[in] the text label vertical and horizontal positioning option respectively to the main dimension line.

◆ FirstPoint()

const gp_Pnt& AIS_AngleDimension::FirstPoint ( ) const
inline
Returns
first point forming the angle.

◆ FirstShape()

const TopoDS_Shape& AIS_AngleDimension::FirstShape ( ) const
inline
Returns
first argument shape.

◆ FitTextAlignment()

void AIS_AngleDimension::FitTextAlignment ( const Prs3d_DimensionTextHorizontalPosition theHorizontalTextPos,
Standard_Integer theLabelPosition,
Standard_Boolean theIsArrowsExternal 
) const
protected

Fits text alignment relatively to the dimension line; it computes the value of label position and arrow orientation according set in the aspect and dimension properties.

Parameters
theHorizontalTextPos[in] the horizontal alignment for text position.
theLabelPosition[out] the label position, contains bits that defines vertical and horizontal alignment. (for internal usage in count text position).
theIsArrowExternal[out] is the arrows external, if arrow orientation in the dimension aspect is Prs3d_DAO_Fit, it fits arrow orientation automatically.

◆ GetArrowsVisibility()

AIS_TypeOfAngleArrowVisibility AIS_AngleDimension::GetArrowsVisibility ( ) const
inline
Returns
the type of visibility of arrows.

◆ GetCenterOnArc()

gp_Pnt AIS_AngleDimension::GetCenterOnArc ( const gp_Pnt theFirstAttach,
const gp_Pnt theSecondAttach,
const gp_Pnt theCenter 
) const
protected
Parameters
theFirstAttach[in] the first attachment point.
theSecondAttach[in] the second attachment point.
theCenter[in] the center point (center point of the angle).
Returns
the center of the dimension arc (the main dimension line in case of angle).

◆ GetDisplayUnits()

virtual const TCollection_AsciiString& AIS_AngleDimension::GetDisplayUnits ( ) const
overridevirtual
Returns
the display units string.

Reimplemented from AIS_Dimension.

◆ GetModelUnits()

virtual const TCollection_AsciiString& AIS_AngleDimension::GetModelUnits ( ) const
overridevirtual
Returns
the model units string.

Reimplemented from AIS_Dimension.

◆ GetNormalForMinAngle()

gp_Dir AIS_AngleDimension::GetNormalForMinAngle ( ) const
protected

Gets plane normal for minimal angle. Dimension computation is based on three attach points and plane normal. Based on this normal angle arc, arrows and extensions are constructed.

◆ GetTextPosition()

virtual const gp_Pnt AIS_AngleDimension::GetTextPosition ( ) const
overridevirtual

Computes absolute text position from dimension parameters (flyout, plane and text alignment).

Reimplemented from AIS_Dimension.

◆ GetType()

AIS_TypeOfAngle AIS_AngleDimension::GetType ( ) const
inline
Returns
the current angle type.

◆ Init()

void AIS_AngleDimension::Init ( )
protected

Initialization of fields that is common to all constructors.

◆ InitConeAngle()

Standard_Boolean AIS_AngleDimension::InitConeAngle ( )
protected

Init angular dimension to measure cone face.

Returns
TRUE if the angular dimension can be constructed for the passed cone.

◆ InitTwoEdgesAngle()

Standard_Boolean AIS_AngleDimension::InitTwoEdgesAngle ( gp_Pln theComputedPlane)
protected

Init angular dimension to measure angle between two linear edges.

Returns
TRUE if the angular dimension can be constructured for the passed edges.

◆ InitTwoFacesAngle() [1/2]

Standard_Boolean AIS_AngleDimension::InitTwoFacesAngle ( )
protected

Init angular dimension to measure angle between two planar faces. there is no user-defined poisitoning. So attach points are set according to faces geometry (in origin of the first face basis surface).

Returns
TRUE if the angular dimension can be constructed for the passed faces.

◆ InitTwoFacesAngle() [2/2]

Standard_Boolean AIS_AngleDimension::InitTwoFacesAngle ( const gp_Pnt  thePointOnFirstFace)
protected

Init angular dimension to measure angle between two planar faces.

Parameters
thePointOnFirstFace[in] the point which the dimension plane should pass through. This point can lay on the one of the faces or not. It will be projected on the first face and this point will be set as the first point attach point. It defines some kind of dimension positioning over the faces.
Returns
TRUE if the angular dimension can be constructed for the passed faces.

◆ isArrowVisible()

Standard_Boolean AIS_AngleDimension::isArrowVisible ( const AIS_TypeOfAngleArrowVisibility theArrowType) const
protected

Returns true if the arrow should be visible.

Parameters
theArrowTypean arrow type
Returns
TRUE if the arrow should be visible

◆ IsValidPoints()

Standard_Boolean AIS_AngleDimension::IsValidPoints ( const gp_Pnt theFirstPoint,
const gp_Pnt theCenterPoint,
const gp_Pnt theSecondPoint 
) const
protected

Check that the points forming angle are valid.

Returns
TRUE if the points met the following requirements: The (P1, Center), (P2, Center) can be built. The angle between the vectors > Precision::Angular().

◆ SecondPoint()

const gp_Pnt& AIS_AngleDimension::SecondPoint ( ) const
inline
Returns
second point forming the angle.

◆ SecondShape()

const TopoDS_Shape& AIS_AngleDimension::SecondShape ( ) const
inline
Returns
second argument shape.

◆ SetArrowsVisibility()

void AIS_AngleDimension::SetArrowsVisibility ( const AIS_TypeOfAngleArrowVisibility theType)
inline

Sets visible arrows type.

Parameters
theType[in] the type of visibility of arrows.

◆ SetDisplayUnits()

virtual void AIS_AngleDimension::SetDisplayUnits ( const TCollection_AsciiString theUnits)
overridevirtual

Reimplemented from AIS_Dimension.

◆ SetMeasuredGeometry() [1/6]

void AIS_AngleDimension::SetMeasuredGeometry ( const TopoDS_Edge theFirstEdge,
const TopoDS_Edge theSecondEdge 
)

Measures minimum angle dimension between two linear edges. These two edges should be intersected by each other. Otherwise the geometry is not valid.

Parameters
theFirstEdge[in] the first edge.
theSecondEdge[in] the second edge.

◆ SetMeasuredGeometry() [2/6]

void AIS_AngleDimension::SetMeasuredGeometry ( const gp_Pnt theFirstPoint,
const gp_Pnt theSecondPoint,
const gp_Pnt theThridPoint 
)

Measures angle defined by three points.

Parameters
theFirstPoint[in] the first point (point on first angle flyout).
theSecondPoint[in] the center point of angle dimension.
theThirdPoint[in] the second point (point on second angle flyout).

◆ SetMeasuredGeometry() [3/6]

void AIS_AngleDimension::SetMeasuredGeometry ( const TopoDS_Vertex theFirstVertex,
const TopoDS_Vertex theSecondVertex,
const TopoDS_Vertex theThirdVertex 
)

Measures angle defined by three vertices.

Parameters
theFirstVertex[in] the first vertex (vertex for first angle flyout).
theSecondVertex[in] the center vertex of angle dimension.
theThirdPoint[in] the second vertex (vertex for second angle flyout).

◆ SetMeasuredGeometry() [4/6]

void AIS_AngleDimension::SetMeasuredGeometry ( const TopoDS_Face theCone)

Measures angle of conical face.

Parameters
theCone[in] the shape to measure.

◆ SetMeasuredGeometry() [5/6]

void AIS_AngleDimension::SetMeasuredGeometry ( const TopoDS_Face theFirstFace,
const TopoDS_Face theSecondFace 
)

Measures angle between two planar faces.

Parameters
theFirstFace[in] the first face.
theSecondFace[in] the second face..

◆ SetMeasuredGeometry() [6/6]

void AIS_AngleDimension::SetMeasuredGeometry ( const TopoDS_Face theFirstFace,
const TopoDS_Face theSecondFace,
const gp_Pnt thePoint 
)

Measures angle between two planar faces.

Parameters
theFirstFace[in] the first face.
theSecondFace[in] the second face.
thePoint[in] the point which the dimension plane should pass through. This point can lay on the one of the faces or not.

◆ SetModelUnits()

virtual void AIS_AngleDimension::SetModelUnits ( const TCollection_AsciiString theUnits)
overridevirtual

Reimplemented from AIS_Dimension.

◆ SetTextPosition()

virtual void AIS_AngleDimension::SetTextPosition ( const gp_Pnt theTextPos)
overridevirtual

Principle of horizontal text alignment settings:

  • divide circle into two halves according to attachment points
  • if aTextPos is between attach points -> Center + positive flyout
  • if aTextPos is not between attach points but in this half -> Left or Right + positive flyout
  • if aTextPos is between reflections of attach points -> Center + negative flyout
  • if aTextPos is not between reflections of attach points -> Left or Right + negative flyout

Reimplemented from AIS_Dimension.

◆ SetType()

void AIS_AngleDimension::SetType ( const AIS_TypeOfAngle  theType)
inline

Sets angle type.

Parameters
theType[in] the type value.

◆ ThirdShape()

const TopoDS_Shape& AIS_AngleDimension::ThirdShape ( ) const
inline
Returns
third argument shape.

The documentation for this class was generated from the following file: